<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_PackageCalendarPriceItems ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_PackageCalendarPriceItems extends AbstractStructArrayBase
{
    /**
     * The PackageCalendarPriceItems
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_PackageCalendarPriceItems[]
     */
    public $PackageCalendarPriceItems;
    /**
     * Constructor method for ArrayOfJP_PackageCalendarPriceItems
     * @uses ArrayOfJP_PackageCalendarPriceItems::setPackageCalendarPriceItems()
     * @param \StructType\JP_PackageCalendarPriceItems[] $packageCalendarPriceItems
     */
    public function __construct(array $packageCalendarPriceItems = array())
    {
        $this
            ->setPackageCalendarPriceItems($packageCalendarPriceItems);
    }
    /**
     * Get PackageCalendarPriceItems value
     * @return \StructType\JP_PackageCalendarPriceItems[]|null
     */
    public function getPackageCalendarPriceItems()
    {
        return $this->PackageCalendarPriceItems;
    }
    /**
     * Set PackageCalendarPriceItems value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PackageCalendarPriceItems[] $packageCalendarPriceItems
     * @return \ArrayType\ArrayOfJP_PackageCalendarPriceItems
     */
    public function setPackageCalendarPriceItems(array $packageCalendarPriceItems = array())
    {
        foreach ($packageCalendarPriceItems as $arrayOfJP_PackageCalendarPriceItemsPackageCalendarPriceItemsItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_PackageCalendarPriceItemsPackageCalendarPriceItemsItem instanceof \StructType\JP_PackageCalendarPriceItems) {
                throw new \InvalidArgumentException(sprintf('The PackageCalendarPriceItems property can only contain items of \StructType\JP_PackageCalendarPriceItems, "%s" given', is_object($arrayOfJP_PackageCalendarPriceItemsPackageCalendarPriceItemsItem) ? get_class($arrayOfJP_PackageCalendarPriceItemsPackageCalendarPriceItemsItem) : gettype($arrayOfJP_PackageCalendarPriceItemsPackageCalendarPriceItemsItem)), __LINE__);
            }
        }
        $this->PackageCalendarPriceItems = $packageCalendarPriceItems;
        return $this;
    }
    /**
     * Add item to PackageCalendarPriceItems value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PackageCalendarPriceItems $item
     * @return \ArrayType\ArrayOfJP_PackageCalendarPriceItems
     */
    public function addToPackageCalendarPriceItems(\StructType\JP_PackageCalendarPriceItems $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_PackageCalendarPriceItems) {
            throw new \InvalidArgumentException(sprintf('The PackageCalendarPriceItems property can only contain items of \StructType\JP_PackageCalendarPriceItems, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PackageCalendarPriceItems[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_PackageCalendarPriceItems|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_PackageCalendarPriceItems|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_PackageCalendarPriceItems|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_PackageCalendarPriceItems|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_PackageCalendarPriceItems|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PackageCalendarPriceItems
     */
    public function getAttributeName()
    {
        return 'PackageCalendarPriceItems';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_PackageCalendarPriceItems
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
